package parser;

public class NodeFactory {

 private NodeFactory() { }

 static public Node newInstance (String creationString) {
  creationString = trim(creationString);
  creationString = deleteSenselessParentheses(creationString);
  try {
   double nurEineZahl = Double.valueOf(creationString).doubleValue();
   return new NumberNode(nurEineZahl);
  }
  catch ( NumberFormatException e ) {
  }
  if ( creationString.length() == 1 ) { 
   return new VariableNode(creationString.charAt(0));
  }
  creationString = repairPreStandingMinus(creationString);
  return new BranchNode(creationString);
 }

 static private String repairPreStandingMinus(String buff) {
  if ( buff.length() < 2 ) {
   return buff;
  }
  if ( buff.charAt(0) == '-' && !Character.isDigit(buff.charAt(1)) ) {
   return "-1*"+buff.substring(1);
  }
  return buff;
 }

 static private String deleteSenselessParentheses(String buff) {
  int ka=0,kea=0;
  boolean operatorFound = false;

  for (int i = 0 ; i< buff.length() ; i++) {
   if (buff.charAt(i)=='(') ka++;
   if (buff.charAt(i)==')') ka--;
   if (buff.charAt(i)=='[') kea++;
   if (buff.charAt(i)==']') kea--;
   if (buff.charAt(i)=='+' && ka==0 && kea==0) { operatorFound=true; break; }
   if (buff.charAt(i)=='-' && ka==0 && kea==0) { operatorFound=true; break; }
   if (buff.charAt(i)=='*' && ka==0 && kea==0) { operatorFound=true; break; }
   if (buff.charAt(i)=='/' && ka==0 && kea==0) { operatorFound=true; break; }
   if (buff.charAt(i)=='^' && ka==0 && kea==0) { operatorFound=true; break; }
  }

  if ( operatorFound ) {
   return buff;
  }

  int anzahlKlammernAuf = 0;
  int anzahlKlammernZu = 0;
  for ( int i = 0 ; i < buff.length() ; i++ ) {
   if ( buff.charAt(i) == '(' ) {
    anzahlKlammernAuf++;
   }
   else {
    break;
   }
  }
  for ( int i = buff.length()-1 ; i >= 0 ; i-- ) {
   if ( buff.charAt(i) == ')' ) {
    anzahlKlammernZu++;
   }
   else {
    break;
   }
  }
  int anzahlKlammernZuDelete = Math.min(anzahlKlammernAuf, anzahlKlammernZu);
  if ( anzahlKlammernZuDelete > 0 ) {
   buff = buff.substring(0, buff.length()-anzahlKlammernZuDelete);
   buff = buff.substring(anzahlKlammernZuDelete);
  }
  return buff;
 }

 static private String trim(String string) {
  if ( string.indexOf(' ') == -1 && string.indexOf((char)9) == -1 ) {
   return string;
  }
  StringBuffer buff = new StringBuffer(string.length());
  char c;
  for ( int i = 0 ; i < string.length() ; i++) {
   c = string.charAt(i);
   if ( c != 32 && c != 9 ) {
    buff.append(c);
   }
  }
  return buff.toString();
 }

}
